image: maven:3.6-jdk-8-alpine

variables:
  MAVEN_CLI_OPTS: "-s .m2/settings.xml --batch-mode"
  MAVEN_OPTS: "-Dmaven.repo.local=.m2/repository"

cache:
  paths:
    - .m2/repository/
    - ocean-server/target/
    - public

before_script:
  - apk add fontconfig ttf-dejavu graphviz npm

ocean_build:
  stage: build
  script: mvn $MAVEN_CLI_OPTS clean install

ocean_deploy:
  stage: deploy
  script:
    - mvn $MAVEN_CLI_OPTS deploy
  only:
    - master
    - tags

pages:
  stage: deploy
  environment:
    name: production
    url: https://ocean.gitlab.io/
  script:
    - export PROJECT_VERSION=`cat ocean-server/target/maven-archiver/pom.properties | grep 'version=' | cut -d'=' -f 2`
    - mvn site
    - for i in $(find . -maxdepth 1 -mindepth 1 -type d); do for j in $(find $i/* -type d -name target); do m=$(dirname $j); m=$(basename $m); mkdir target/site/$m; cp -R $j/site/* target/site/$m/; done; done
    - if [ ! -d public ]; then mkdir public; fi
    - if [ -d "public/$PROJECT_VERSION" ]; then rm -Rf public/$PROJECT_VERSION; fi
    - mv target/site public/$PROJECT_VERSION
    - chmod -R a+rw public
  artifacts:
    paths:
      - public
  only:
    - master
    - tags
  tags:
    - docker

ocean_server:
  stage: build
  image: docker:19.03.1
  services:
    - docker:19.03.1-dind
  variables:
    # Use TLS https://docs.gitlab.com/ee/ci/docker/using_docker_build.html#tls-enabled
    DOCKER_HOST: tcp://docker:2376
    DOCKER_TLS_CERTDIR: "/certs"
  script:
    - docker login -u $MAVEN_REPO_USER -p $MAVEN_REPO_PASS registry.waveinformatica.com
    - cd ocean-server/target
    - export PROJECT_VERSION=`cat maven-archiver/pom.properties | grep 'version=' | cut -d'=' -f 2`
    - docker build -t wave/ocean-server:$PROJECT_VERSION .
    - docker tag wave/ocean-server:$PROJECT_VERSION registry.waveinformatica.com/wave/ocean-server:$PROJECT_VERSION
    - docker push registry.waveinformatica.com/wave/ocean-server:$PROJECT_VERSION
    - docker tag wave/ocean-server:$PROJECT_VERSION registry.waveinformatica.com/wave/ocean-server:latest
    - docker push registry.waveinformatica.com/wave/ocean-server:latest
  only:
    - master
    - tags

#sast:
#  image: docker:stable
#  variables:
#    DOCKER_DRIVER: overlay2
#  allow_failure: true
#  services:
#    - docker:stable-dind
#  script:
#    - export SP_VERSION=$(echo "$CI_SERVER_VERSION" | sed 's/^\([0-9]*\)\.\([0-9]*\).*/\1-\2-stable/')
#    - docker run
#        --env SAST_CONFIDENCE_LEVEL="${SAST_CONFIDENCE_LEVEL:-3}"
#        --env MAVEN_OPTS="-Dmaven.repo.local=/code/.m2/repository"
#        --volume "$PWD:/code"
#        --volume /var/run/docker.sock:/var/run/docker.sock
#        "registry.gitlab.com/gitlab-org/security-products/sast:$SP_VERSION" /app/bin/run /code
#  artifacts:
#    reports:
#      sast: gl-sast-report.json


#dependency_scanning:
#  image: docker:stable
#  variables:
#    DOCKER_DRIVER: overlay2
#  allow_failure: true
#  services:
#    - docker:stable-dind
#  script:
#    - export SP_VERSION=$(echo "$CI_SERVER_VERSION" | sed 's/^\([0-9]*\)\.\([0-9]*\).*/\1-\2-stable/')
#    - docker run
#        --env DEP_SCAN_DISABLE_REMOTE_CHECKS="${DEP_SCAN_DISABLE_REMOTE_CHECKS:-false}"
#        --volume "$PWD:/code"
#        --volume /var/run/docker.sock:/var/run/docker.sock
#        "registry.gitlab.com/gitlab-org/security-products/dependency-scanning:$SP_VERSION" /code
#  artifacts:
#    reports:
#      dependency_scanning: gl-dependency-scanning-report.json
